Bullet Collision Detection & Physics Library: btConvex2dShape Class Reference

Bullet Collision Detection & Physics Library

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | Private Attributes | List of all members
btConvex2dShape Class Reference

The btConvex2dShape allows to use arbitrary convex shapes as 2d convex shapes, with the Z component assumed to be 0. More...

`#include <btConvex2dShape.h>`

Inheritance diagram for btConvex2dShape:
[legend]
Collaboration diagram for btConvex2dShape:
[legend]

## Public Member Functions
| BT_DECLARE_ALIGNED_ALLOCATOR ()
| btConvex2dShape (btConvexShape *convexChildShape)
virtual | ~btConvex2dShape ()
virtual btVector3 | localGetSupportingVertexWithoutMargin (const btVector3 &vec) const
virtual btVector3 | localGetSupportingVertex (const btVector3 &vec) const
virtual void | batchedUnitVectorGetSupportingVertexWithoutMargin (const btVector3 *vectors, btVector3 *supportVerticesOut, int numVectors) const
virtual void | calculateLocalInertia (btScalar mass, btVector3 &inertia) const
btConvexShape * | getChildShape ()
const btConvexShape * | getChildShape () const
virtual const char * | getName () const
void | getAabb (const btTransform &t, btVector3 &aabbMin, btVector3 &aabbMax) const
| getAabb's default implementation is brute force, expected derived classes to implement a fast dedicated version More...
virtual void | getAabbSlow (const btTransform &t, btVector3 &aabbMin, btVector3 &aabbMax) const
virtual void | setLocalScaling (const btVector3 &scaling)
virtual const btVector3 & | getLocalScaling () const
virtual void | setMargin (btScalar margin)
virtual btScalar | getMargin () const
virtual int | getNumPreferredPenetrationDirections () const
virtual void | getPreferredPenetrationDirection (int index, btVector3 &penetrationVector) const
Public Member Functions inherited from btConvexShape
| BT_DECLARE_ALIGNED_ALLOCATOR ()
| btConvexShape ()
| not supported on IBM SDK, until we fix the alignment of btVector3 More...
virtual | ~btConvexShape ()
btVector3 | localGetSupportVertexWithoutMarginNonVirtual (const btVector3 &vec) const
btVector3 | localGetSupportVertexNonVirtual (const btVector3 &vec) const
btScalar | getMarginNonVirtual () const
void | getAabbNonVirtual (const btTransform &t, btVector3 &aabbMin, btVector3 &aabbMax) const
virtual void | project (const btTransform &trans, const btVector3 &dir, btScalar &minProj, btScalar &maxProj, btVector3 &witnesPtMin, btVector3 &witnesPtMax) const
Public Member Functions inherited from btCollisionShape
| BT_DECLARE_ALIGNED_ALLOCATOR ()
| btCollisionShape ()
virtual | ~btCollisionShape ()
virtual void | getBoundingSphere (btVector3 &center, btScalar &radius) const
virtual btScalar | getAngularMotionDisc () const
| getAngularMotionDisc returns the maximus radius needed for Conservative Advancement to handle time-of-impact with rotations. More...
virtual btScalar | getContactBreakingThreshold (btScalar defaultContactThresholdFactor) const
void | calculateTemporalAabb (const btTransform &curTrans, const btVector3 &linvel, const btVector3 &angvel, btScalar timeStep, btVector3 &temporalAabbMin, btVector3 &temporalAabbMax) const
| calculateTemporalAabb calculates the enclosing aabb for the moving object over interval [0..timeStep) result is conservative More...
bool | isPolyhedral () const
bool | isConvex2d () const
bool | isConvex () const
bool | isNonMoving () const
bool | isConcave () const
bool | isCompound () const
bool | isSoftBody () const
bool | isInfinite () const
| isInfinite is used to catch simulation error (aabb check) More...
int | getShapeType () const
virtual btVector3 | getAnisotropicRollingFrictionDirection () const
| the getAnisotropicRollingFrictionDirection can be used in combination with setAnisotropicFriction See Bullet/Demos/RollingFrictionDemo for an example More...
void | setUserPointer (void *userPtr)
| optional user data pointer More...
void * | getUserPointer () const
void | setUserIndex (int index)
int | getUserIndex () const
virtual int | calculateSerializeBufferSize () const
virtual const char * | serialize (void *dataBuffer, btSerializer *serializer) const
| fills the dataBuffer and returns the struct name (and 0 on failure) More...
virtual void | serializeSingleShape (btSerializer *serializer) const

## Private Attributes
btConvexShape * | m_childConvexShape

## Additional Inherited Members
Protected Attributes inherited from btCollisionShape
int | m_shapeType
void * | m_userPointer
int | m_userIndex

## Detailed Description

The btConvex2dShape allows to use arbitrary convex shapes as 2d convex shapes, with the Z component assumed to be 0.

For 2d boxes, the btBox2dShape is recommended.

Definition at line 24 of file btConvex2dShape.h.

## Constructor & Destructor Documentation

btConvex2dShape::btConvex2dShape | ( | btConvexShape * | convexChildShape | ) |

Definition at line 18 of file btConvex2dShape.cpp.

btConvex2dShape::~btConvex2dShape | ( |  | ) |
| virtual

Definition at line 24 of file btConvex2dShape.cpp.

## Member Function Documentation

void btConvex2dShape::batchedUnitVectorGetSupportingVertexWithoutMargin | ( | const btVector3 * | vectors,
|  | btVector3 * | supportVerticesOut,
|  | int | numVectors
| ) |  | const
| virtual

Implements btConvexShape.

Definition at line 35 of file btConvex2dShape.cpp.

btConvex2dShape::BT_DECLARE_ALIGNED_ALLOCATOR | ( |  | ) |

void btConvex2dShape::calculateLocalInertia | ( | btScalar | mass,
|  | btVector3 & | inertia
| ) |  | const
| virtual

this linear upscaling is not realistic, but we don't deal with large mass ratios...

Implements btCollisionShape.

Definition at line 47 of file btConvex2dShape.cpp.

void btConvex2dShape::getAabb | ( | const btTransform & | t,
|  | btVector3 & | aabbMin,
|  | btVector3 & | aabbMax
| ) |  | const
| virtual

getAabb's default implementation is brute force, expected derived classes to implement a fast dedicated version

Implements btConvexShape.

Definition at line 55 of file btConvex2dShape.cpp.

void btConvex2dShape::getAabbSlow | ( | const btTransform & | t,
|  | btVector3 & | aabbMin,
|  | btVector3 & | aabbMax
| ) |  | const
| virtual

Implements btConvexShape.

Definition at line 60 of file btConvex2dShape.cpp.

btConvexShape* btConvex2dShape::getChildShape | ( |  | ) |
| inline

Definition at line 44 of file btConvex2dShape.h.

const btConvexShape* btConvex2dShape::getChildShape | ( |  | ) | const
| inline

Definition at line 49 of file btConvex2dShape.h.

const btVector3 & btConvex2dShape::getLocalScaling | ( |  | ) | const
| virtual

Implements btConvexShape.

Definition at line 70 of file btConvex2dShape.cpp.

btScalar btConvex2dShape::getMargin | ( |  | ) | const
| virtual

Implements btConvexShape.

Definition at line 79 of file btConvex2dShape.cpp.

virtual const char* btConvex2dShape::getName | ( |  | ) | const
| inlinevirtual

Implements btCollisionShape.

Definition at line 54 of file btConvex2dShape.h.

int btConvex2dShape::getNumPreferredPenetrationDirections | ( |  | ) | const
| virtual

Implements btConvexShape.

Definition at line 84 of file btConvex2dShape.cpp.

void btConvex2dShape::getPreferredPenetrationDirection | ( | int | index,
|  | btVector3 & | penetrationVector
| ) |  | const
| virtual

Implements btConvexShape.

Definition at line 89 of file btConvex2dShape.cpp.

btVector3 btConvex2dShape::localGetSupportingVertex | ( | const btVector3 & | vec | ) | const
| virtual

Implements btConvexShape.

Definition at line 41 of file btConvex2dShape.cpp.

btVector3 btConvex2dShape::localGetSupportingVertexWithoutMargin | ( | const btVector3 & | vec | ) | const
| virtual

Implements btConvexShape.

Definition at line 30 of file btConvex2dShape.cpp.

void btConvex2dShape::setLocalScaling | ( | const btVector3 & | scaling | ) |
| virtual

Implements btConvexShape.

Definition at line 65 of file btConvex2dShape.cpp.

void btConvex2dShape::setMargin | ( | btScalar | margin | ) |
| virtual

Implements btConvexShape.

Definition at line 75 of file btConvex2dShape.cpp.

## Member Data Documentation

btConvexShape* btConvex2dShape::m_childConvexShape
| private

Definition at line 26 of file btConvex2dShape.h.

The documentation for this class was generated from the following files:

- btConvex2dShape.h
- btConvex2dShape.cpp